#!/usr/local/bin/perl -w
# 
# Writer:         wangxy <wxyang1988@126.com>
# Program Date:   2011.
# Modifier:       wangxy <wxyang1988@126.com>
# Last Modified:  2011.
##########################################################

my $ver="1.0";

use strict;
use Getopt::Long;
use Data::Dumper;
use FindBin qw($Bin $Script);
use File::Basename qw(basename dirname);

#########################################################

my %opts;
GetOptions(\%opts,"id=s","od=s","h" ); 

#&help()if(defined $opts{h});
if(!defined($opts{id}) || !defined($opts{od}) ||defined($opts{h}))
{
	print <<"	Usage End.";
	Description:
		
		Version: $ver

	Usage:

		-id     Input folder                    must be given

		-od     Output folder                 must be given

		-h    Help document

	Usage End.

	exit;
}

###############Time
my $Time_Start;
$Time_Start = sub_format_datetime(localtime(time()));
print "\nStart Time :[$Time_Start]\n\n";
################
my $programe_dir=basename($0);
my $ind=$opts{id};
my $outdir=$opts{od};

`rm -r $outdir ` if(-d $outdir);
mkdir($outdir) if(!-d $outdir);

my @file=glob"$ind/*.fasta";

for (my $j=0;$j<@file ;$j++) 
{
	my $file_name=(split/\//,$file[$j])[-1];
	my $seq_name=(split/\./,$file_name)[0];
	open OUT,">$outdir/rename.$file_name" || die "Can't create $outdir/rename.$file_name,$!\n";
	open IN,"$file[$j]" || die "Can't open $file[$j],$!\n" ;
	while (<IN>) 
	{
		chomp;
		if (/^>/) 
		{
			my $seq_num;
			my $name1=(split /;/,$_)[0];
			if ($name1=~ m/Cluster(\d+)/) {$seq_num=$1;}
			print OUT ">",$seq_name,"_",$seq_num,"\n";
		}
		else {print OUT "$_\n";}
	}
	close (IN);
	close (OUT);
}

###############Time
my $Time_End;
$Time_End = sub_format_datetime(localtime(time()));
print "\nEnd Time :[$Time_End]\n\n";

###############Subs
sub sub_format_datetime {#Time calculation subroutine
	my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = @_;
	$wday = $yday = $isdst = 0;
	sprintf("%4d-%02d-%02d %02d:%02d:%02d", $year+1900, $mon+1, $day, $hour, $min, $sec);
}
