#!/usr/local/bin/perl -w
# 
# Writer:         wangxy <wxyang1988@126.com>
# Program Date:   2011.
# Modifier:       wangxy <wxyang1988@126.com>
# Last Modified:  2011.
##########################################################

my $ver="1.0";

use strict;
use Getopt::Long;
use Data::Dumper;
use FindBin qw($Bin $Script);
use File::Basename qw(basename dirname);

#########################################################

my %opts;
GetOptions(\%opts,"id=s","n=s","o=s","h" ); 

#&help()if(defined $opts{h});
if(!defined($opts{id}) || !defined($opts{o}) ||defined($opts{h}))
{
	print <<"	Usage End.";
	Description:
		
		Version: $ver

	Usage:

		-id     Input folder                    must be given

		-n     Number of reference sequence   must be given

		-o     Output file                 must be given

		-h    Help document

	Usage End.

	exit;
}

###############Time
my $Time_Start;
$Time_Start = sub_format_datetime(localtime(time()));
print "\nStart Time :[$Time_Start]\n\n";
################
my $programe_dir=basename($0);
my $ind=$opts{id};
my $num=$opts{n};
my $out=$opts{o};
#my $outdir=$opts{od};

#`rm -r $outdir ` if(-d $outdir);
#mkdir($outdir) if(!-d $outdir);

my @file=glob"$ind/*.fasta";

open (OUT,">$out") || die "Can't creat $out,$!\n" ;

my %hnumb = () ;

for (my $j=0;$j<@file ;$j++) {

open (IN,"$file[$j]") || die "Can't open $file[$j],$!\n" ;
my $id = <IN> ; chomp $id ;
my $seq = <IN> ; chomp $seq ;
my $len = length $seq ;
for (my $i=0; $i<$len; $i++){
	my $base = substr($seq, $i, 1) ;
	if ($base eq "!" || $base eq "-"){
		$hnumb{$i} = 1 ;
	}
}
for (my $i=1; $i<$num; $i++){
	$id = <IN> ; chomp $id ;
	$seq = <IN> ; chomp $seq ;
	for my $numb (keys %hnumb){
		my $base = substr($seq, $numb, 1) ;
		if ($base ne "!" && $base ne "-"){
			delete $hnumb{$numb} ;
		}
	}
}

if (keys %hnumb == $len){
	print "Warning: please chech the file\n" ;
}

while(<IN>){
	chomp ;
	if (m/^\>/){
		print OUT $_,"\n" ;
	}
	else{
		my $count = 0 ;
		for (my $i=0; $i<$len; $i++){
			next if (defined $hnumb{$i}) ;
			print OUT substr($_, $i, 1) ;
		}
		print OUT "\n" ;
	}
}
close(IN);
}

close(OUT);

###############Time
my $Time_End;
$Time_End = sub_format_datetime(localtime(time()));
print "\nEnd Time :[$Time_End]\n\n";

###############Subs
sub sub_format_datetime {#Time calculation subroutine
    my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = @_;
	$wday = $yday = $isdst = 0;
    sprintf("%4d-%02d-%02d %02d:%02d:%02d", $year+1900, $mon+1, $day, $hour, $min, $sec);
}
