#!/usr/local/bin/perl -w
# 
# Writer:         wangxy <wxyang1988@126.com>
# Program Date:   2011.
# Modifier:       wangxy <wxyang1988@126.com>
# Last Modified:  2011.
##########################################################

my $ver="1.0";

use strict;
use Getopt::Long;
use Data::Dumper;
use FindBin qw($Bin $Script);
use File::Basename qw(basename dirname);

#########################################################

my %opts;
GetOptions(\%opts,"i=s","n=s","od=s","h" ); 

#&help()if(defined $opts{h});
if(!defined($opts{i}) || !defined($opts{n}) || !defined($opts{od}) ||defined($opts{h}))
{
	print <<"	Usage End.";
	Description:
		
		Version: $ver

	Usage:

		-i     Input file                 must be given

		-n     Number of splited          must be given

		-od    Output directory           must be given

		-h    Help document

	Usage End.

	exit;
}

###############Time
my $Time_Start;
$Time_Start = sub_format_datetime(localtime(time()));
print "\nStart Time :[$Time_Start]\n\n";
################
my $programe_dir=basename($0);
my $in=$opts{i};
my $splited_num=$opts{n};
my $outdir=$opts{od};

`rm -r $outdir ` if(-d $outdir);
mkdir($outdir) if(!-d $outdir);

my $count;
my %Seq;

my $name=(split/\./,$in)[0];

print "$name\n";
#die;

open IN,"$in" || die "Can't open $in\n" ;
$/=">";
<IN>;
while (<IN>)
{
   chomp;
   $count++;
   $Seq{$count}=$_;
}

#print "$count\n";
my $size=int(($count)/$splited_num)+1;
#print "$size\n";


my $k=1;   
for (my $i=1;$i<=$count;$i+=$size)
{
    open OUT,">$outdir/$name.$k" || die "~~~~~~~~~~~~~~~~!";
    $k++;
    for (my $j=$i;$j<$i+$size;$j++)
    {
       if ($j>$count) {}
       else
       {  
          print OUT ">$Seq{$j}";
       }
    }
close (OUT);
}




close (IN);
#close (OUT);

###############Time
my $Time_End;
$Time_End = sub_format_datetime(localtime(time()));
print "\nEnd Time :[$Time_End]\n\n";

###############Subs
sub sub_format_datetime {#Time calculation subroutine
    my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = @_;
	$wday = $yday = $isdst = 0;
    sprintf("%4d-%02d-%02d %02d:%02d:%02d", $year+1900, $mon+1, $day, $hour, $min, $sec);
}
